scala.actors

# Actor

#### trait Actor extends AbstractActor with ReplyReactor with ActorCanReply with InputChannel[Any] with Serializable

Provides lightweight, concurrent actors. Actors are created by extending the `Actor` trait (alternatively, one of the factory methods in its companion object can be used). The behavior of an `Actor` subclass is defined by implementing its `act` method:

      class MyActor extends Actor {
        def act() {
          // actor behavior goes here
        }
      }

A new `Actor` instance is started by invoking its `start` method.

Note: care must be taken when invoking thread-blocking methods other than those provided by the `Actor` trait or its companion object (such as `receive`). Blocking the underlying thread inside an actor may lead to starvation of other actors. This also applies to actors hogging their thread for a long time between invoking `receive`/`react`.

If actors use blocking operations (for example, methods for blocking I/O), there are several options:

- The run-time system can be configured to use a larger thread pool size (for example, by setting the `actors.corePoolSize` JVM property).
- The `scheduler` method of the `Actor` trait can be overridden to return a `ResizableThreadPoolScheduler`, which resizes its thread pool to avoid starvation caused by actors that invoke arbitrary blocking methods.
- The `actors.enableForkJoin` JVM property can be set to `false`, in which case a `ResizableThreadPoolScheduler` is used by default to execute actors.

The main ideas of the implementation are explained in the two papers

- Event-Based Programming without Inversion of Control, Philipp Haller and Martin Odersky, Proc. JMLC 2006, and

- Actors that Unify Threads and Events, Philipp Haller and Martin Odersky, Proc. COORDINATION 2007.

Annotations
  @SerialVersionUID( uid = 781154067877019505L )
Source
  Actor.scala

Linear Supertypes
Serializable, Serializable, InputChannel[Any], ActorCanReply, ReplyReactor, ReactorCanReply, Reactor[Any], Combinators, AbstractActor, CanReply[Any, Any], OutputChannel[Any], AnyRef, Any
Known Subclasses
DaemonActor, SwingWorker
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. Actor
2. Serializable
3. Serializable
4. InputChannel
5. ActorCanReply
6. ReplyReactor
7. ReactorCanReply
8. Reactor
9. Combinators
10. AbstractActor
11. CanReply
12. OutputChannel
13. AnyRef
14. Any

Visibility

1. Public
2. All

### Type Members

1. #### type Future[+P] = Future[P]

   Definition Classes
     ReactorCanReply → CanReply

### Abstract Value Members

1. #### abstract def act(): Unit

   The actor's behavior is specified by implementing this method.

   The actor's behavior is specified by implementing this method.

   Definition Classes
     Reactor

### Concrete Value Members

1. #### def !(msg: Any): Unit

   Sends `msg` to this actor (asynchronous).

   Sends `msg` to this actor (asynchronous).

   msg

     the message to send

   Definition Classes
     ReplyReactor → Reactor → OutputChannel

2. #### def !!(msg: Any): Future[Any]

   Sends `msg` to this actor and immediately returns a future representing the reply value.

   Sends `msg` to this actor and immediately returns a future representing the reply value.

   msg

     the message to be sent

   returns

     the future

   Definition Classes
     ActorCanReply → ReactorCanReply → CanReply

3. #### def !![A](msg: Any, handler: PartialFunction[Any, A]): Future[A]

   Sends `msg` to this actor and immediately returns a future representing the reply value.

   Sends `msg` to this actor and immediately returns a future representing the reply value. The reply is post-processed using the partial function `handler`. This also allows to recover a more precise type for the reply value.

   msg

     the message to be sent

   handler

     the function to be applied to the response

   returns

     the future

   Definition Classes
     ActorCanReply → ReactorCanReply → CanReply

4. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

6. #### def !?(msec: Long, msg: Any): Option[Any]

   Sends `msg` to this actor and awaits reply (synchronous) within `msec` milliseconds.

   Sends `msg` to this actor and awaits reply (synchronous) within `msec` milliseconds.

   msec

     the time span before timeout

   msg

     the message to be sent

   returns

     `None` in case of timeout, otherwise `Some(x)` where `x` is the reply

   Definition Classes
     ActorCanReply → ReactorCanReply → CanReply

7. #### def !?(msg: Any): Any

   Sends `msg` to this actor and awaits reply (synchronous).

   Sends `msg` to this actor and awaits reply (synchronous).

   msg

     the message to be sent

   returns

     the reply

   Definition Classes
     ActorCanReply → ReactorCanReply → CanReply

8. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

9. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

10. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

11. #### def ?: Any

    Receives the next message from the mailbox

    Receives the next message from the mailbox

    Definition Classes
      Actor → InputChannel

12. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

13. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

14. #### def continue(): Unit

    Continues with the execution of the closure registered as continuation following `andThen`.

    Continues with the execution of the closure registered as continuation following `andThen`. Continues with the execution of the next loop iteration when invoked inside the body of `loop` or `loopWhile`.

    Definition Classes
      Combinators

15. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

16. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. See equals in Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

17. #### def exceptionHandler: PartialFunction[Exception, Unit]

    This partial function is applied to exceptions that propagate out of this actor's body.

    This partial function is applied to exceptions that propagate out of this actor's body.

    Attributes
      protected[actors]
    Definition Classes
      Reactor

18. #### def exit(): Nothing

    Terminates with exit reason `'normal`.

    Terminates with exit reason `'normal`.

    Attributes
      protected[actors]
    Definition Classes
      Actor → Reactor

19. #### def exit(reason: AnyRef): Nothing

    Terminates execution of `self` with the following effect on linked actors:

    Terminates execution of `self` with the following effect on linked actors:

    For each linked actor `a` with `trapExit` set to `true`, send message `Exit(self, reason)` to `a`.

    For each linked actor `a` with `trapExit` set to `false` (default), call `a.exit(reason)` if `reason != 'normal`.

    Attributes
      protected[actors]

20. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

21. #### def forward(msg: Any): Unit

    Forwards `msg` to this actor (asynchronous).

    Forwards `msg` to this actor (asynchronous).

    msg

      the message to forward

    Definition Classes
      ReplyReactor → Reactor → OutputChannel

22. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

23. #### def getState: Value

    State of this actor

    State of this actor

    returns

      the execution state

    Definition Classes
      Actor → ReplyReactor → Reactor

24. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

25. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

26. #### def link(body: ⇒ Unit): Actor

    Links `self` to the actor defined by `body`.

    Links `self` to the actor defined by `body`.

    body

      the body of the actor to link to

    returns

      the parameter actor

27. #### def link(to: AbstractActor): AbstractActor

    Links `self` to actor `to`.

    Links `self` to actor `to`.

    to

      the actor to link to

    returns

      the parameter actor

28. #### def loop(body: ⇒ Unit): Unit

    Repeatedly executes `body`.

    Repeatedly executes `body`.

    body

      the block to be executed

    Definition Classes
      Combinators

29. #### def loopWhile(cond: ⇒ Boolean)(body: ⇒ Unit): Unit

    Repeatedly executes `body` while the condition `cond` is `true`.

    Repeatedly executes `body` while the condition `cond` is `true`.

    cond

      the condition to test

    body

      the block to be executed

    Definition Classes
      Combinators

30. #### def mailboxSize: Int

    Attributes
      protected[actors]
    Definition Classes
      Reactor

31. #### implicit def mkBody[A](body: ⇒ A): Body[A]

    Enables the composition of suspendable closures using `andThen`, `loop`, `loopWhile`, etc.

    Enables the composition of suspendable closures using `andThen`, `loop`, `loopWhile`, etc.

    Definition Classes
      Reactor → Combinators

32. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

33. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

34. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

35. #### def react(handler: PartialFunction[Any, Unit]): Nothing

    See the companion object's `react` method.

    See the companion object's `react` method.

    Definition Classes
      Actor → InputChannel → ReplyReactor → Reactor

36. #### def reactWithin(msec: Long)(handler: PartialFunction[Any, Unit]): Nothing

    See the companion object's `reactWithin` method.

    See the companion object's `reactWithin` method.

    msec

      the time span before timeout

    Definition Classes
      Actor → InputChannel → ReplyReactor

37. #### def receive[R](f: PartialFunction[Any, R]): R

    See the companion object's `receive` method.

    See the companion object's `receive` method.

    f

      a partial function with message patterns and actions

    returns

      result of processing the received value

    Definition Classes
      Actor → InputChannel

38. #### def receiveWithin[R](msec: Long)(f: PartialFunction[Any, R]): R

    See the companion object's `receiveWithin` method.

    See the companion object's `receiveWithin` method.

    msec

      the time span before timeout

    f

      a partial function with message patterns and actions

    returns

      result of processing the received value

    Definition Classes
      Actor → InputChannel

39. #### def receiver: Actor

    Returns the `Actor` that is receiving from this actor.

    Returns the `Actor` that is receiving from this actor.

    Definition Classes
      Reactor → OutputChannel

40. #### def reply(msg: Any): Unit

    Replies with `msg` to the sender.

    Replies with `msg` to the sender.

    Attributes
      protected[actors]
    Definition Classes
      ReplyReactor

41. #### def restart(): Unit

    Restarts this actor.

    Restarts this actor.

    Definition Classes
      Reactor
    Exceptions thrown
      java.lang.IllegalStateException

      if the actor is not in state `Actor.State.Terminated`

42. #### def scheduler: IScheduler

    Attributes
      protected[actors]
    Definition Classes
      Actor → Reactor

43. #### def send(msg: Any, replyTo: OutputChannel[Any]): Unit

    Sends `msg` to this actor (asynchronous) supplying explicit reply destination.

    Sends `msg` to this actor (asynchronous) supplying explicit reply destination.

    msg

      the message to send

    replyTo

      the reply destination

    Definition Classes
      Reactor → OutputChannel

44. #### def sender: OutputChannel[Any]

    Returns the actor which sent the last received message.

    Returns the actor which sent the last received message.

    Attributes
      protected[actors]
    Definition Classes
      ReplyReactor

45. #### def start(): Actor

    Starts this actor.

    Starts this actor. This method is idempotent.

    Definition Classes
      Actor → Reactor

46. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

47. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

48. #### var trapExit: Boolean

49. #### def unlink(from: AbstractActor): Unit

    Unlinks `self` from actor `from`.

50. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

51. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

52. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

### Inherited from Serializable

### Inherited from InputChannel[Any]

### Inherited from ActorCanReply

### Inherited from ReplyReactor

### Inherited from ReactorCanReply

### Inherited from Reactor[Any]

### Inherited from Combinators

### Inherited from AbstractActor

### Inherited from CanReply[Any, Any]

### Inherited from OutputChannel[Any]

### Inherited from AnyRef

### Inherited from Any